#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdbool.h>
#include "bt.h"

BinaryTree* BT_create() {
  BinaryTree* bt = malloc(sizeof(BinaryTree));
  bt->node_count = 0;
  bt->root = NULL;
  return bt;
}

BinaryTreeNode* BT_insert_helper(BinaryTreeNode* cur, char* val) {
  if (cur == NULL) {
    BinaryTreeNode* node = malloc(sizeof(BinaryTreeNode));
    node->value = malloc(strlen(val) + 1);
    strcpy(node->value, val);
    node->left = NULL;
    node->right = NULL;
    return node;
  }
  int res = strcmp(val, cur->value);
  if (res == 0) { return cur; }
  if (res < 0) {
    cur->left = BT_insert_helper(cur->left, val);
  } else {
    cur->right = BT_insert_helper(cur->right, val);
  }
  return cur;
}

void BT_insert(BinaryTree* bt, char* val) {
  bt->root = BT_insert_helper(bt->root, val);
}

void BT_print_helper(BinaryTreeNode* cur, int level) {
  if (cur == NULL) {
    return;
  }
  for (int i = 0; i < level; i++) {
    printf("  ");
  }
  printf("[ADDR: %p  LEFT: %p  RIGHT: %p  VAL: %s]\n", cur, cur->left, cur->right, cur->value);
  BT_print_helper(cur->left, level+1);
  BT_print_helper(cur->right, level+1);
}

void BT_print(BinaryTree* tree) {
  BT_print_helper(tree->root, 0);
}

bool BT_contains_helper(BinaryTreeNode* cur, char* val) {
  if (cur == NULL) {
    return false;
  }
  int res = strcmp(val, cur->value);
  if (res == 0) { 
    return true; 
  }
  if (res < 0) {
    return BT_contains_helper(cur->left, val);
  } else {
    return BT_contains_helper(cur->right, val);
  }
}

bool BT_contains(BinaryTree* bt, char* val) { 
  return BT_contains_helper(bt->root, val);
}

